/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of passwdqc.xs. Do not edit this file, edit passwdqc.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "passwdqc.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "passwdqc.h"

SV *
password_generate(const char *packed_params)
{
    const char *pass;
    const passwdqc_params_qc_t *params = (passwdqc_params_qc_t *)packed_params;

    pass = passwdqc_random(params);

    if (!pass)
        return &PL_sv_undef;
     return newSVpvn(pass, strlen(pass));
}

SV *
password_check(const char *packed_params, const char *new_pass, const char *old_pass, const char *pw_name, const char *pw_gecos)
{
    const char *reason;
    const passwdqc_params_qc_t *params = (passwdqc_params_qc_t *)packed_params;

    /* this is inspired by what passwdqc does on non-unix platforms */
    struct passwd fake_pw, *pw;
    memset(&fake_pw, 0, sizeof(fake_pw));
    fake_pw.pw_name  = pw_name ? (char *)pw_name : "";
    fake_pw.pw_gecos = pw_gecos ? (char *)pw_gecos : "";
    fake_pw.pw_dir   = "";
    if (pw_name != NULL || pw_gecos != NULL) {
        pw = &fake_pw;
    }
    else {
        pw = NULL;
    }

    reason = passwdqc_check(params, new_pass, old_pass, pw);

    if (!reason)
        return &PL_sv_undef;
    return newSVpvn(reason, strlen(reason));
}


#line 59 "passwdqc.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 203 "passwdqc.c"

XS_EUPXS(XS_Data__Password__passwdqc_password_generate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Password__passwdqc_password_generate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "packed_params");
    {
	const char *	packed_params = (const char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;

	RETVAL = password_generate(packed_params);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Password__passwdqc_password_check); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Password__passwdqc_password_check)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "packed_params, new_pass, ...");
    {
	const char *	packed_params = (const char *)SvPV_nolen(ST(0))
;
	const char *	new_pass = (const char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;
#line 63 "passwdqc.xs"
        switch (items) {
            case 5:
                RETVAL = password_check(packed_params, new_pass,
                            SvOK(ST(2)) ? (char *)SvPV_nolen(ST(2)) : NULL,
                            SvOK(ST(3)) ? (char *)SvPV_nolen(ST(3)) : NULL,
                            SvOK(ST(4)) ? (char *)SvPV_nolen(ST(4)) : NULL);
                break;
            case 4:
                RETVAL = password_check(packed_params, new_pass,
                            SvOK(ST(2)) ? (char *)SvPV_nolen(ST(2)) : NULL,
                            SvOK(ST(3)) ? (char *)SvPV_nolen(ST(3)) : NULL,
                            NULL);
                break;
            case 3:
                RETVAL = password_check(packed_params, new_pass,
                            SvOK(ST(2)) ? (char *)SvPV_nolen(ST(2)) : NULL,
                            NULL,
                            NULL);
                break;
            case 2:
                RETVAL = password_check(packed_params, new_pass, NULL, NULL, NULL);
                break;
            default:
                croak("password_check() called with too few arguments!");
                break;
        }
#line 263 "passwdqc.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Password__passwdqc__test_params); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Password__passwdqc__test_params)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "packed_params");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	packed_params = (const char *)SvPV_nolen(ST(0))
;
#line 96 "passwdqc.xs"
        const passwdqc_params_qc_t * params;
#line 284 "passwdqc.c"
#line 98 "passwdqc.xs"
        params = (passwdqc_params_qc_t *)packed_params;
        EXTEND(SP, 10);
        PUSHs(sv_2mortal(newSViv(params->min[0])));
        PUSHs(sv_2mortal(newSViv(params->min[1])));
        PUSHs(sv_2mortal(newSViv(params->min[2])));
        PUSHs(sv_2mortal(newSViv(params->min[3])));
        PUSHs(sv_2mortal(newSViv(params->min[4])));
        PUSHs(sv_2mortal(newSViv(params->max)));
        PUSHs(sv_2mortal(newSViv(params->passphrase_words)));
        PUSHs(sv_2mortal(newSViv(params->match_length)));
        PUSHs(sv_2mortal(newSViv(params->similar_deny)));
        PUSHs(sv_2mortal(newSViv(params->random_bits)));
#line 298 "passwdqc.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Data__Password__passwdqc__test_int_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Password__passwdqc__test_int_max)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 114 "passwdqc.xs"
        RETVAL = newSViv(INT_MAX);
#line 315 "passwdqc.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Data__Password__passwdqc); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Data__Password__passwdqc)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Data::Password::passwdqc::password_generate", XS_Data__Password__passwdqc_password_generate);
        newXS_deffile("Data::Password::passwdqc::password_check", XS_Data__Password__passwdqc_password_check);
        newXS_deffile("Data::Password::passwdqc::_test_params", XS_Data__Password__passwdqc__test_params);
        newXS_deffile("Data::Password::passwdqc::_test_int_max", XS_Data__Password__passwdqc__test_int_max);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
